import org.junit.Test;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

public class Aufgabe2Test {

    @Test
    public void testEmptyToString() throws Exception {

        Tree tree = new Tree();

        assertThat(tree.toString().replaceAll("\\s", ""), is("[]"));

    }

    @Test
    public void testToString() throws Exception {

        Tree tree = new Tree();

        tree.add(1);
        tree.add(4);
        tree.add(3);
        tree.add(2);
        tree.add(5);
        tree.add(2);

        assertThat(tree.toString().replaceAll("\\s", ""), is("[1,2,2,3,4,5]"));

    }

    @Test
    public void testEmptySumLevel() throws Exception {

        Tree tree = new Tree();

        assertThat(tree.sumLevel(0), is(0));
        assertThat(tree.sumLevel(1), is(0));

    }

    @Test
    public void testEmptyLevelSumLevel() throws Exception {

        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);
        tree.add(8);

        assertThat(tree.sumLevel(4), is(0));

    }

    @Test
    public void testSumLevel() throws Exception {

        Tree tree = new Tree();

        tree.add(5);
        tree.add(2);
        tree.add(1);
        tree.add(7);
        tree.add(6);
        tree.add(8);

        assertThat(tree.sumLevel(0), is(5));
        assertThat(tree.sumLevel(1), is(9));
        assertThat(tree.sumLevel(2), is(15));

    }

}